TEMPLATE = app
QT += xml
CONFIG += qt debug
TARGET = freshmemory

!win32 {
    MOC_DIR = .moc
    OBJECTS_DIR = .obj
    RCC_DIR = .rcc
    UI_DIR = .ui
}

HEADERS += src/MTestModel.h \
           src/TAppModel.h \
           src/TCard.h \
           src/TDictionary.h \
           src/TDictTableModel.h \
           src/TDictTableView.h \
           src/TEditDelegate.h \
           src/TFlashcardsTestModel.h \
           src/TFlashcardsTestWindow.h \
           src/TMainWindow.h \
           src/MTestWindow.h \
           src/MSingleton.h \
           src/TFindDialog.h \
           src/TDictParser.h \
           src/TStudyFileParser.h \
           src/TCSVImportDialog.h \
           src/TCSVExportDialog.h \
           src/CSVData.h \
           src/TSpacedRepetitionModel.h \
           src/TSpacedRepetitionWindow.h \
           src/TFieldManager.h \
           src/version.h
SOURCES += src/main.cpp \
           src/MTestModel.cpp \
           src/TAppModel.cpp \
           src/TCard.cpp \
           src/TDictionary.cpp \
           src/TDictTableModel.cpp \
           src/TDictTableView.cpp \
           src/TEditDelegate.cpp \
           src/TFlashcardsTestModel.cpp \
           src/TFlashcardsTestWindow.cpp \
           src/TMainWindow.cpp \
           src/MTestWindow.cpp \
           src/TFindDialog.cpp \
           src/TDictParser.cpp \
           src/TStudyFileParser.cpp \
           src/TCSVImportDialog.cpp \
           src/TCSVExportDialog.cpp \
           src/TSpacedRepetitionModel.cpp \
           src/TSpacedRepetitionWindow.cpp \
           src/TFieldManager.cpp
RESOURCES += application.qrc

# Maemo specific
unix {
    BINDIR = /opt/usr/bin
    DATADIR = /opt/usr/share

    DEFINES += DATADIR=\"$$DATADIR\" \
               PKGDATADIR=\"$$PKGDATADIR\"

    INSTALLS += target desktop icon64 dictionaries

    target.path = $$BINDIR

    desktop.path = /usr/share/applications/hildon
    desktop.files += data/freshmemory.desktop

    icon64.path = $$DATADIR/icons/hicolor/64x64/apps
    icon64.files += data/64x64/freshmemory.png

    dictionaries.path = $$DATADIR/freshmemory/
    dictionaries.files += dictionaries/eng-rus-20081215.fmd
    dictionaries.files += dictionaries/fin-rus-20081215.fmd
} else:win32 {
    target.path = "C:\Program Files\FreshMemory"

    INSTALLS = target
}
